﻿using System;
using System.Configuration;
using System.Data.SqlClient;

namespace Anbo1DatabaseConsoleClient
{
    class Program
    {
        // connection string can be saved in the App.config file
        //private const string ConnectionString =
        //    "Server=tcp:hcx0ty48uo.database.windows.net,1433;Database=anbo1database;User ID=iot@hcx0ty48uo;Password=Secret12;Encrypt=True;TrustServerCertificate=False;Connection Timeout=30;";
        private const string SelectAllStudents = "select * from student";
        private const string InsertStudent = "insert into student (name, phone) values (@name, @phone)";

        static void Main()
        {
            string connString = GetConnectionStringFromAppConfig();

            using (SqlConnection databaseConnection = new SqlConnection(connString))
            {
                databaseConnection.Open();
                //ShowAllStudents(databaseConnection);
                InsertStudents(databaseConnection);
                ShowAllStudents(databaseConnection);
            }
        }

        private static string GetConnectionStringFromAppConfig()
        {
            // https://msdn.microsoft.com/en-us/library/ms254494.aspx
            ConnectionStringSettingsCollection connectionStringSettingsCollection = ConfigurationManager.ConnectionStrings;
            ConnectionStringSettings connStringSettings = connectionStringSettingsCollection["anbo1databaseAzure"];
            string connString = connStringSettings.ConnectionString;
            return connString;
        }

        private static void ShowAllStudents(SqlConnection databaseConnection)
        {
            using (SqlCommand selectCommand = new SqlCommand(SelectAllStudents, databaseConnection))
            {
                using (SqlDataReader reader = selectCommand.ExecuteReader())
                {
                    if (reader.HasRows)
                    {
                        while (reader.Read())
                        {
                            int id = reader.GetInt32(0);
                            string name = reader.GetString(1);
                            string phone = reader.GetString(2);
                            DateTime timeStamp = reader.GetDateTime(3);
                            // normally you would not show the ID to the user
                            Console.WriteLine(id + " " + name + " " + phone + " " + timeStamp);
                        }
                    }
                    else
                    {
                        Console.WriteLine("No rows");
                    }
                }
            }
        }
        private static void InsertStudents(SqlConnection databaseConnection)
        {
            while (true)
            {
                Console.Write("Name: ");
                string name = Console.ReadLine();
                if (string.IsNullOrWhiteSpace(name)) break;
                Console.Write("Phone: ");
                string phone = Console.ReadLine();
                if (string.IsNullOrWhiteSpace(phone)) break;
                using (SqlCommand insertCommand = new SqlCommand(InsertStudent, databaseConnection))
                {
                    insertCommand.Parameters.AddWithValue("@name", name);
                    insertCommand.Parameters.AddWithValue("@phone", phone);
                    int rowsAffected = insertCommand.ExecuteNonQuery();
                    Console.WriteLine(rowsAffected + " row(s) affected");
                }
            }
        }
    }
}